diff --git a/cdist/conf/type/__filesystem/explorer/lsblk b/cdist/conf/type/__filesystem/explorer/lsblk
new file mode 100644
index 00000000..9ae544ac
--- /dev/null
+++ b/cdist/conf/type/__filesystem/explorer/lsblk
@@ -0,0 +1,43 @@
+#!/bin/sh
+#
+# 2016 - 2016 Daniel Heule (hda at sfs.biz)
+#
+# This file is part of cdist.
+#
+# cdist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# cdist is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with cdist. If not, see .
+#
+
+os=$("$__explorer/os")
+
+if [ -f "$__object/parameter/device" ]; then
+ blkdev="$(cat "$__object/parameter/device")"
+else
+ blkdev="$__object_id"
+fi
+
+case "$os" in
+ centos|fedora|redhat|suse|gentoo)
+ if [ ! -x "$(command -v lsblk)" ]; then
+ echo "lsblk is required for __filesystem type" >&2
+ exit 1
+ else
+ #echo -n $(lsblk -nd -P -o NAME,FSTYPE,LABEL,MOUNTPOINT "$blkdev" 2>/dev/null)
+ lsblk -nd -P -o NAME,FSTYPE,LABEL,MOUNTPOINT "$blkdev" 2>/dev/null
+ fi
+ ;;
+ *)
+ echo "__filesystem type lacks implementation for os: $os" >&2
+ exit 1
+ ;;
+esac
diff --git a/cdist/conf/type/__filesystem/gencode-remote b/cdist/conf/type/__filesystem/gencode-remote
new file mode 100644
index 00000000..3ca1c498
--- /dev/null
+++ b/cdist/conf/type/__filesystem/gencode-remote
@@ -0,0 +1,102 @@
+#!/bin/sh
+#
+# 2016 - 2016 Daniel Heule (hda at sfs.biz)
+#
+# This file is part of cdist.
+#
+# cdist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# cdist is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with cdist. If not, see .
+#
+
+
+fstype="$(cat "$__object/parameter/fstype")"
+
+if [ -f "$__object/parameter/device" ]; then
+ mydev="$(cat "$__object/parameter/device")"
+else
+ mydev="$__object_id"
+fi
+
+label="$(cat "$__object/parameter/label")"
+mkfsoptions="$(cat "$__object/parameter/mkfsoptions")"
+
+
+if [ -f "$__object/parameter/force" ]; then
+ # create filesystem even an other filesystem is on disk or the label is not correct, use with caution !
+ forcefs="true"
+else
+ forcefs="false"
+fi
+
+
+
+blkdev_devname="$(grep -P -o 'NAME="\K[^"]*' "$__object/explorer/lsblk")"
+blkdev_fstype="$(grep -P -o 'FSTYPE="\K[^"]*' "$__object/explorer/lsblk")"
+blkdev_label="$(grep -P -o 'LABEL="\K[^"]*' "$__object/explorer/lsblk")"
+blkdev_mountpoint="$(grep -P -o 'MOUNTPOINT="\K[^"]*' "$__object/explorer/lsblk")"
+
+if [ -z "$blkdev_devname" ]; then
+ echo "Specified device $mydev not found on target system" >&2
+ exit 1
+fi
+
+[ "$blkdev_label" = "$label" ] && [ "$blkdev_fstype" = "$fstype" ] && exit 0
+
+if [ -n "$blkdev_mountpoint" ]; then
+ echo "Specified device $mydev is mounted on $blkdev_mountpoint, __filesystem does NOTHING with mountd devices" >&2
+ exit 0
+fi
+
+if [ -n "$blkdev_fstype" ] && [ "$forcefs" != "true" ]; then
+ if [ "$blkdev_label" != "$label" ]; then
+ echo "Specified device $mydev has not the spezified label: $blkdev_label, but __filesystem does NOTHING in this case without the --force option" >&2
+ exit 0
+ fi
+ if [ "$blkdev_fstype" != "$fstype" ]; then
+ echo "Specified device $mydev has not the spezified filesystem: $blkdev_fstype, but __filesystem does NOTHING in this case without the --force option" >&2
+ exit 0
+ fi
+fi
+
+
+# ok, all conditions checked, we need to format the device, lets go
+opts="$mkfsoptions"
+if [ -n "$label" ]; then
+ opts="$opts -L '$label'"
+fi
+
+case "$fstype" in
+ ext2|ext3|ext4)
+ if [ "$forcefs" = "true" ]; then
+ opts="$opts -F"
+ fi
+ echo "mkfs.$fstype $opts /dev/$blkdev_devname"
+ ;;
+ btrfs)
+ if [ "$forcefs" = "true" ]; then
+ opts="$opts --force"
+ fi
+ echo "mkfs.btrfs $opts /dev/$blkdev_devname"
+ ;;
+ xfs)
+ if [ "$forcefs" = "true" ]; then
+ opts="$opts -f"
+ fi
+ echo "mkfs.xfs $opts /dev/$blkdev_devname"
+ ;;
+ *)
+ echo "__filesystem type lacks implementation for filesystem: $fstype" >&2
+ exit 1
+ ;;
+esac
+echo "filesystem $fstype on $mydev : /dev/$blkdev_devname created" >> "$__messages_out"
diff --git a/cdist/conf/type/__filesystem/man.rst b/cdist/conf/type/__filesystem/man.rst
new file mode 100644
index 00000000..c69cc839
--- /dev/null
+++ b/cdist/conf/type/__filesystem/man.rst
@@ -0,0 +1,80 @@
+cdist-type__filesystem(7)
+=========================
+
+NAME
+----
+cdist-type__filesystem - Create Filesystems.
+
+
+DESCRIPTION
+-----------
+This cdist type allows you to create filesystems on devices.
+
+If the device is mounted on target, it refuses to do someting.
+
+If the device has a filesystem other as the specified and/or
+ the label is not correct, it only make a new filesystem
+ if you specified --force option
+
+
+REQUIRED PARAMETERS
+-------------------
+fstype
+ Filesystem type, for example 'ext3', 'btrfs' or 'xfs'
+
+
+
+OPTIONAL PARAMETERS
+-------------------
+device
+ Blockdevice for filesystem, Defaults to object_id.
+ On linux, it can be any by lsblk accepted device notation
+
+ for example
+ /dev/sdx
+ or /dev/disk/by-xxxx/xxx
+ or /dev/mapper/xxxx
+
+label
+ Label which sould apply on the filesystem
+
+mkfsoptions
+ Additional options which are inserted to the mkfs.xxx call.
+
+
+BOOLEAN PARAMETERS
+------------------
+force
+ Normaly, this type does nothing if a filesystem is found
+ on the target device. If you specify force, its formated
+ if the filesystem type or label differs from parameters
+ Warning: This option can easy lead into data loss !
+
+MESSAGES
+--------
+filesystem on : created
+ Filesytem was created on
+
+
+EXAMPLES
+--------
+
+.. code-block:: sh
+
+ # Ensures that device /dev/sdb is formated with xfs
+ __filesystem /dev/sdb --fstype xfs --label Testdisk1
+ # The same thing with btrfs and disk spezified by pci path to disk 1:0 on vmware
+ __filesystem dev_sdb --fstype btrfs --device /dev/disk/by-path/pci-0000:0b:00.0-scsi-0:0:0:0 --label Testdisk2
+ # Make sure that a multipath san device has a filesystem ...
+ __filesystem dev_sdb --fstype xfs --device /dev/mapper/360060e80432f560050202f22000023ff --label Testdisk3
+
+
+AUTHORS
+-------
+Daniel Heule
+
+
+COPYING
+-------
+Copyright \(C) 2016 Daniel Heule. Free use of this software is
+granted under the terms of the GNU General Public License version 3 or any later version (GPLv3+).
diff --git a/cdist/conf/type/__filesystem/parameter/boolean b/cdist/conf/type/__filesystem/parameter/boolean
new file mode 100644
index 00000000..14b33226
--- /dev/null
+++ b/cdist/conf/type/__filesystem/parameter/boolean
@@ -0,0 +1 @@
+force
diff --git a/cdist/conf/type/__filesystem/parameter/default/label b/cdist/conf/type/__filesystem/parameter/default/label
new file mode 100644
index 00000000..e69de29b
diff --git a/cdist/conf/type/__filesystem/parameter/default/mkfsoptions b/cdist/conf/type/__filesystem/parameter/default/mkfsoptions
new file mode 100644
index 00000000..e69de29b
diff --git a/cdist/conf/type/__filesystem/parameter/optional b/cdist/conf/type/__filesystem/parameter/optional
new file mode 100644
index 00000000..79dddc21
--- /dev/null
+++ b/cdist/conf/type/__filesystem/parameter/optional
@@ -0,0 +1,3 @@
+device
+label
+mkfsoptions
diff --git a/cdist/conf/type/__filesystem/parameter/required b/cdist/conf/type/__filesystem/parameter/required
new file mode 100644
index 00000000..98f8b69f
--- /dev/null
+++ b/cdist/conf/type/__filesystem/parameter/required
@@ -0,0 +1 @@
+fstype
diff --git a/cdist/conf/type/__sysctl/explorer/value b/cdist/conf/type/__sysctl/explorer/value
new file mode 100755
index 00000000..fc85b3d8
--- /dev/null
+++ b/cdist/conf/type/__sysctl/explorer/value
@@ -0,0 +1,22 @@
+#!/bin/sh
+#
+# 2014 Steven Armstrong (steven-cdist at armstrong.cc)
+#
+# This file is part of cdist.
+#
+# cdist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# cdist is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with cdist. If not, see .
+#
+
+# get the current runtime value
+sysctl -n "$__object_id" || true
diff --git a/cdist/conf/type/__sysctl/gencode-remote b/cdist/conf/type/__sysctl/gencode-remote
new file mode 100755
index 00000000..0f3b0b40
--- /dev/null
+++ b/cdist/conf/type/__sysctl/gencode-remote
@@ -0,0 +1,30 @@
+#!/bin/sh
+#
+# 2014 Steven Armstrong (steven-cdist at armstrong.cc)
+#
+# This file is part of cdist.
+#
+# cdist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# cdist is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with cdist. If not, see .
+#
+
+value_should="$(cat "$__object/parameter/value")"
+value_is="$(cat "$__object/explorer/value")"
+
+if [ "$value_should" = "$value_is" ]; then
+ # Nothing to do
+ exit 0
+fi
+
+# set the current runtime value
+printf 'sysctl -w %s="%s"\n' "$__object_id" "$value_should"
diff --git a/cdist/conf/type/__sysctl/man.rst b/cdist/conf/type/__sysctl/man.rst
new file mode 100644
index 00000000..d5c6495c
--- /dev/null
+++ b/cdist/conf/type/__sysctl/man.rst
@@ -0,0 +1,39 @@
+cdist-type__sysctl(7)
+=====================
+
+NAME
+----
+cdist-type__sysctl - manage sysctl settings
+
+
+DESCRIPTION
+-----------
+Manages permanent as well as runtime sysctl settings.
+Permament settings are set by managing entries in /etc/sysctl.conf.
+Runtime settings are set by directly calling the sysctl executable.
+
+
+REQUIRED PARAMETERS
+-------------------
+value::
+ The value to set for the given key (object_id)
+
+
+EXAMPLES
+--------
+
+.. code-block:: sh
+
+ __sysctl net.ipv4.ip_forward --value 1
+
+
+AUTHORS
+-------
+Steven Armstrong
+
+
+COPYING
+-------
+Copyright \(C) 2014 Steven Armstrong. Free use of this software is
+granted under the terms of the GNU General Public License version 3 or
+later (GPLv3+).
diff --git a/cdist/conf/type/__sysctl/manifest b/cdist/conf/type/__sysctl/manifest
new file mode 100755
index 00000000..dd317806
--- /dev/null
+++ b/cdist/conf/type/__sysctl/manifest
@@ -0,0 +1,39 @@
+#!/bin/sh
+#
+# 2014 Steven Armstrong (steven-cdist at armstrong.cc)
+#
+# This file is part of cdist.
+#
+# cdist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# cdist is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with cdist. If not, see .
+#
+
+
+os=$(cat "$__global/explorer/os")
+
+case "$os" in
+ redhat|centos|ubuntu|debian|archlinux)
+ :
+ ;;
+ *)
+ echo "Your operating system ($os) is currently not supported by this type (${__type##*/})." >&2
+ echo "Please contribute an implementation for it if you can." >&2
+ exit 1
+ ;;
+esac
+
+__key_value "$__object_name" \
+ --key "$__object_id" \
+ --file /etc/sysctl.conf \
+ --value "$(cat "$__object/parameter/value")" \
+ --delimiter '='
diff --git a/cdist/conf/type/__sysctl/parameter/required b/cdist/conf/type/__sysctl/parameter/required
new file mode 100644
index 00000000..6d4e1507
--- /dev/null
+++ b/cdist/conf/type/__sysctl/parameter/required
@@ -0,0 +1 @@
+value
diff --git a/docs/changelog b/docs/changelog
index 47e6237c..5dd49ef5 100644
--- a/docs/changelog
+++ b/docs/changelog
@@ -1,8 +1,10 @@
Changelog
---------
-
next:
+ * New type __filesystem: manage filesystems on devices ( Daniel Heule )
+
* New type: __locale_system (Steven Armstrong, Carlos Ortigoza, Nico Schottelius)
+ * New type: __sysctl (Steven Armstrong)
4.2.2: 2016-07-26
* Core: Fix ssh ControlPath socket file error (Darko Poljak)